// MDBView.h : interface of the CMDBView class
//
/////////////////////////////////////////////////////////////////////////////

class CMDBView : public CTreeView
{
protected: // create from serialization only
	void SetModified();
	CMDBView();
	DECLARE_DYNCREATE(CMDBView)

// Attributes
public:
	HTREEITEM FieldInfoIterator( CString & strFieldName, 
								int & nFieldType, 
								int & nTextFieldLength,
								HTREEITEM hTable = NULL );
	HTREEITEM TableNameIterator( CString & str, BOOLEAN bReset = FALSE );
	CMDBDoc* GetDocument();

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMDBView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	virtual void OnInitialUpdate(); // called first time after construct
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CMDBView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CMDBView)
	afx_msg void OnEndlabeledit(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnBeginlabeledit(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnFileTable();
	afx_msg void OnFileField();
	afx_msg void OnUpdateFileField(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFileFieldDelete(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFileTableDelete(CCmdUI* pCmdUI);
	afx_msg void OnFileTableDelete();
	afx_msg void OnFileFieldDelete();
	afx_msg void OnEditSelectedItem();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in MDBView.cpp
inline CMDBDoc* CMDBView::GetDocument()
   { return (CMDBDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////
